unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils,
  System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls,
  Vcl.StdCtrls, math;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Timer1: TTimer;
    Label2: TLabel;
    Label3: TLabel;

    Image1: TImage;
    Label4: TLabel;

    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Label3Click(Sender: TObject);

    procedure figura(xx,yy, th : single);


  private
    { Private declarations }
    x,y         : real;
    xant,yant   : real;

    gam,gamAnt  : real;

    ap,bp  : real;
    A,B    : real;

    w      : real;

    TT,t,dt : real;

    CFondo,CPluma : TColor;

    // para usar la figura
    NP   : integer;
    Fig  : array of TPoint;
    Piv  : TPoint;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// Create
procedure TForm1.FormCreate(Sender: TObject);
begin
  NP := 3;
  SetLength(Fig,NP);

  Fig[0].X := -20;
  Fig[0].Y :=   0;

  Fig[1].X :=  20;
  Fig[1].Y :=   0;

  Fig[2].X :=   0;
  Fig[2].Y := -32;

  Piv.X    :=   0;
  Piv.Y    := -16;

  Image1.Canvas.Brush.Color := clBlue;

  Image1.Canvas.Pen.Color   := clYellow;
  Image1.Canvas.Pen.Width   := 2;

  Image1.Canvas.Rectangle(0,0,560,360);

end;

// Click del Boton
procedure TForm1.Button1Click(Sender: TObject);
begin
  A   := 80;
  B   := 80;

  ap  := 280;
  bp  := 180;

  TT     := StrToFloat(Edit1.Text);
  t      := 0;
  w      := 2*PI/TT;
  dt     := Timer1.Interval/1000;

  gam := 0.0;

  label3.Caption := '>>';

  Timer1.Enabled := true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  xant    := x;
  yant    := y;
  gamAnt  := gam;

  t := t + dt;
  x := ap + A*sin(w*t);
  y := bp - B*cos(w*t);

  gam := gam + 10;

//  Label4.Caption := IntToStr(N);
//  Shape1.left := ceil(x)
//  Shape1.top  := ceil(y)

  figura(x,y, gam);

end;

procedure TForm1.Label3Click(Sender: TObject);
begin
  if (label3.Caption = '>>')
    then begin
      label3.Caption := '||';
      Timer1.Enabled := false;
    end
    else begin
      label3.Caption := '>>';
      Timer1.Enabled := true;
    end;

end;

procedure TForm1.figura(xx,yy, th : single);
var
  CAux    : integer;
  xc, yc  : single;
  st,ct   : single;

  procedure Rota(x1,y1 : single);
  begin
    xc := (x1-Piv.X)*ct - (y1-Piv.Y)*st + Piv.X;
    yc := (x1-Piv.X)*st + (y1-Piv.Y)*ct + Piv.Y;
  end;

  procedure PintaBorra(xxx,yyy : single);
  var
    kk : integer;
  begin
    Rota(Fig[0].X,Fig[0].Y);
    Image1.Canvas.MoveTo( ceil(xxx + xc) ,
                          ceil(yyy + yc) );

    for kk := 1 to NP-1 do begin
      Rota(Fig[kk].X,Fig[kk].Y);
      Image1.Canvas.LineTo( ceil(xxx + xc) ,
                            ceil(yyy + yc) );
    end;

    Rota(Fig[0].X,Fig[0].Y);
    Image1.Canvas.LineTo( ceil(xxx + xc) ,
                          ceil(yyy + yc) );
  end;

begin
  CAux   := Image1.Canvas.Pen.Color;
  CFondo := Image1.Canvas.Brush.Color;

  // Borrar

  th := th*Pi/180;
  st := sin(th);
  ct := cos(th);

  Image1.Canvas.Pen.Color := CFondo;
  PintaBorra(xant,yant);

  // Pintar
  Image1.Canvas.Pen.Color := CAux;
  PintaBorra(xx,yy);

end;

end.
